Subject: RE: [External] : Re: bug#52007: 26.3; Doc of `define-globalized-minor-mode' and global(ized) minor modes

From: Drew Adams <[email-masked]>
Date: Sun, 21 Nov 2021 17:45:53 +0000

> > > >   Toggle Foo mode in all buffers.
> > > >
> > > > It doesn't do that at all.  Instead, it toggles
> > > > `global-foo-mode'.
> > >
> > > No, it turns ON both foo-mode and global-foo-mode.
> >
> > You missed the point of the bug report.
> > Toggling the global mode turns them both on (or off,
> > depending on the current value of `global-foo-mode')
> > in all buffers, yes.
> 
> No.  It turns on foo-mode in all buffers, and it turns on
> global-foo-mode globally -- it is nonsense to talk about "global mode
> in a buffer", because global modes are, well, global.

We agree about what it does, however you prefer
to describe it.

> > That's not what it means to toggle `foo-mode'
> > everywhere.  Doing that would flip the value that
> > `foo-mode' (non-global mode) has in each buffer.
> 
> And it does.

It does not.  If `foo-mode' is on in buffer A, and
the global mode is off, then toggling the global mode
results in `foo-mode' being (still) on in buffer A.

Toggling `foo-mode' in all buffers (which is what
the erroneous doc string said) would turn it on where
it is off and off where it is on.  It would turn it
off in buffer A.  It does not do so; it doesn't
toggle `foo-mode' in each buffer; instead, it turns
the mode on everywhere or off everywhere, depending
on the value of `global-foo-mode'.

> > Glad this will be fixed in Emacs 28.  (And no, I
> > wasn't "looking at an old Emacs".  I reported on
> > the latest Emacs release, Emacs 27.2.)
> 
> Your report said 26.3.

Ah, yes, you're right.  Mea culpa.  I can't use Emacs
27 in general (broken with my setup), and I forgot to
switch to emacs -Q with Emacs 27.2 to file this
particular bug.

But as you've acknowledged, the bug exists in 27.2,
the latest Emacs release.